Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class CastExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.CastExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class CastExpression

extends UnaryExpression

Cast Expression: implements "cast as data-type ( expression )". It also allows an internal cast, which has the same semantics as a user-requested cast, but maps an empty sequence to an empty sequence.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`CastExpression(Expression source, AtomicType target, boolean allowEmpty)`

Method Summary
`boolean` | `allowsEmpty()`
`static AtomicValue` | `castStringToQName(CharSequence operand, AtomicType targetType, StaticContext env)` Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value.
`int` | `computeCardinality()` Get the static cardinality of the expression
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression
`ItemType` | `getItemType(TypeHierarchy th)` Get the static type of the expression
`AtomicType` | `getTargetPrimitiveType()`
`AtomicType` | `getTargetType()`
`static boolean` | `isPossibleCast(int source, int target)` Determine whether casting from a source type to a target type is possible
`boolean` | `isUpCast()`
`Expression` | `simplify(StaticContext env)` Simplify the expression
`boolean` | `targetIsDerived()`
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`display, getBaseExpression, hashCode, iterateSubExpressions, optimize, promote, replaceSubExpression`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CastExpression

    public CastExpression(Expression source,
                          AtomicType target,
                          boolean allowEmpty)

Method Detail

### isPossibleCast

    public static boolean isPossibleCast(int source,
                                         int target)

  Determine whether casting from a source type to a target type is possible

  Parameters:
    `source` - a primitive type (one that has an entry in the casting table)
    `target` - another primitive type
  Returns:
    true if the entry in the casting table is either "Y" (casting always succeeds) or "M" (casting allowed but may fail for some values)

### getTargetPrimitiveType

    public AtomicType getTargetPrimitiveType()

### getTargetType

    public AtomicType getTargetType()

### allowsEmpty

    public boolean allowsEmpty()

### targetIsDerived

    public boolean targetIsDerived()

### isUpCast

    public boolean isUpCast()

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify the expression

  Overrides:
    `simplify` in class `UnaryExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### computeCardinality

    public int computeCardinality()

  Get the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static type of the expression

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` -
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### castStringToQName

    public static AtomicValue castStringToQName(CharSequence operand,
                                                AtomicType targetType,
                                                StaticContext env)
                                         throws XPathException

  Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value. This can only happen at compile time

  Returns:
    the QName or NOTATION value that results from casting the string to a QName. This will either be a QNameValue or a derived AtomicValue derived from QName or NOTATION
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.